'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoadingIcon = exports.ToggleIcon = exports.CloseIcon = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                              * Copyright (c) 2015-present, Zippy Technologies
                                                                                                                                                                                                                              *
                                                                                                                                                                                                                              * This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                              * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                              */

function CloseIcon(_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === undefined ? 10 : _ref$size,
      className = _ref.className,
      svgProps = _ref.svgProps,
      rest = _objectWithoutProperties(_ref, ['size', 'className', 'svgProps']);

  return _react2.default.createElement(
    'div',
    _extends({}, rest, { className: className }),
    _react2.default.createElement(
      'svg',
      _extends({}, svgProps, { width: size, height: size, viewBox: '4 4 16 16' }),
      _react2.default.createElement('path', { d: 'M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z' })
    )
  );
}

CloseIcon.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.number
};

function ToggleIcon(_ref2) {
  var onClick = _ref2.onClick,
      className = _ref2.className,
      expanded = _ref2.expanded,
      _ref2$size = _ref2.size,
      size = _ref2$size === undefined ? 10 : _ref2$size,
      rest = _objectWithoutProperties(_ref2, ['onClick', 'className', 'expanded', 'size']);

  return _react2.default.createElement(
    'div',
    _extends({}, rest, { className: className, onClick: onClick }),
    _react2.default.createElement(
      'svg',
      { height: size, width: size, viewBox: '5 4 14 14' },
      expanded ? _react2.default.createElement('path', { d: 'M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z' }) : _react2.default.createElement('path', { d: 'M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z' })
    )
  );
}

function LoadingIcon(_ref3) {
  var _ref3$size = _ref3.size,
      size = _ref3$size === undefined ? 17 : _ref3$size,
      _ref3$svgProps = _ref3.svgProps,
      svgProps = _ref3$svgProps === undefined ? {} : _ref3$svgProps,
      className = _ref3.className,
      rest = _objectWithoutProperties(_ref3, ['size', 'svgProps', 'className']);

  return _react2.default.createElement(
    'div',
    _extends({}, rest, { className: className }),
    _react2.default.createElement(
      'svg',
      _extends({}, svgProps, { width: size, height: size, viewBox: '0 0 24 24' }),
      _react2.default.createElement('path', { d: 'M12 6v3l4-4-4-4v3c-4.42 0-8 3.58-8 8 0 1.57.46 3.03 1.24 4.26L6.7 14.8c-.45-.83-.7-1.79-.7-2.8 0-3.31 2.69-6 6-6zm6.76 1.74L17.3 9.2c.44.84.7 1.79.7 2.8 0 3.31-2.69 6-6 6v-3l-4 4 4 4v-3c4.42 0 8-3.58 8-8 0-1.57-.46-3.03-1.24-4.26z' })
    )
  );
}

LoadingIcon.propTypes = {
  size: _propTypes2.default.number
};

exports.CloseIcon = CloseIcon;
exports.ToggleIcon = ToggleIcon;
exports.LoadingIcon = LoadingIcon;