'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dragHelper = require('@zippytech/drag-helper');

var _dragHelper2 = _interopRequireDefault(_dragHelper);

var _valueUtils = require('./value-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) 2015-present, Zippy Technologies
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var handleDragInteraction = function handleDragInteraction(event, config, _ref) {
  var currentValue = _ref.currentValue,
      targetRegion = _ref.targetRegion,
      constrainRegion = _ref.constrainRegion,
      dragSize = _ref.dragSize,
      onHandleDragStart = _ref.onHandleDragStart,
      onHandleDrag = _ref.onHandleDrag,
      onHandleDragEnd = _ref.onHandleDragEnd;
  var horizontal = config.horizontal;


  (0, _dragHelper2.default)(event, {
    region: targetRegion,
    constrainTo: constrainRegion,

    onDragStart: onHandleDragStart,

    onDrag: function onDrag(event, dragConfig) {
      var diff = horizontal ? dragConfig.diff.left : dragConfig.diff.top;

      var percentage = diff * 100 / dragSize;
      var diffValue = (0, _valueUtils.getValueForPercentage)(percentage, config, {
        noStartValue: true
      });

      var newValue = currentValue + diffValue;
      onHandleDrag(newValue, diffValue);
    },

    onDrop: onHandleDragEnd
  });
};

exports.default = handleDragInteraction;